import { EventEmitter, OnChanges } from '@angular/core';
import { SelectItem } from 'primeng-lts/api';
import { DeploymentSummaryCompactDescriptor, SummaryCompactHeaderSelectorConfig } from '../types/al-deployment-summary-compact-header.types';
import * as i0 from "@angular/core";
export declare class AlDeploymentSummaryHeaderCompactComponent implements OnChanges {
    data: DeploymentSummaryCompactDescriptor;
    fullScreen: boolean;
    mode: string;
    onSelectOption: EventEmitter<SelectItem>;
    set title(text: string);
    multiSelectsConfigs: SummaryCompactHeaderSelectorConfig[];
    options: SelectItem[];
    ngOnChanges(): void;
    shouldDisplayDropDown(infoBlockIdx: number): boolean;
    setTitle(text: string): void;
    handleSelected(index: number, event: any): void;
    static ɵfac: i0.ɵɵFactoryDef<AlDeploymentSummaryHeaderCompactComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<AlDeploymentSummaryHeaderCompactComponent, "al-deployment-summary-compact-header", never, { "data": "data"; "fullScreen": "fullScreen"; "mode": "mode"; "title": "title"; }, { "onSelectOption": "onSelectOption"; }, never, never>;
}
