import { TooltipConfig } from '../types';
import * as i0 from "@angular/core";
export declare class AlIconBlockComponent {
    /**
     * The matIcon input for icon sets that use ligatures (i.e. Material Icons)
     */
    matIcon: string;
    /**
     * The icon class input for icon sets that use classes (i.e. FontAwesome)
     */
    iconClass: string;
    label: string;
    disabled?: boolean;
    tooltip: TooltipConfig;
    static ɵfac: i0.ɵɵFactoryDef<AlIconBlockComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<AlIconBlockComponent, "al-icon-block", never, { "matIcon": "matIcon"; "iconClass": "iconClass"; "label": "label"; "disabled": "disabled"; "tooltip": "tooltip"; }, {}, never, never>;
}
