import { EventEmitter } from '@angular/core';
import { AlStateFilterDescriptor } from './al-state-filter-descriptor.type';
import * as i0 from "@angular/core";
export declare class AlStateFilterComponent {
    selectedState: AlStateFilterDescriptor;
    stateFilters: {
        value: AlStateFilterDescriptor;
        disabled?: boolean;
    }[];
    filterSelected: EventEmitter<{
        originalEvent: Event;
        value: AlStateFilterDescriptor;
    }>;
    selectState: (event: {
        originalEvent: Event;
        value: AlStateFilterDescriptor;
    }) => void;
    static ɵfac: i0.ɵɵFactoryDef<AlStateFilterComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<AlStateFilterComponent, "al-state-filter", never, { "selectedState": "selectedState"; "stateFilters": "stateFilters"; }, { "filterSelected": "filterSelected"; }, never, never>;
}
