import { OnChanges, SimpleChanges, ElementRef } from '@angular/core';
import { AlExternalContentManagerService } from '../services';
import * as i0 from "@angular/core";
export declare class AlExternalHtmlDirective implements OnChanges {
    externalContent: AlExternalContentManagerService;
    elementRef: ElementRef;
    resource?: string;
    transformer?: {
        (html: string): string | PromiseLike<string>;
    };
    constructor(externalContent: AlExternalContentManagerService, elementRef: ElementRef);
    ngOnChanges(changes: SimpleChanges): void;
    installResourceMarkup(resourceId: string): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDef<AlExternalHtmlDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDefWithMeta<AlExternalHtmlDirective, "[alExternalHtml]", never, { "resource": "alExternalHtml"; "transformer": "transformer"; }, {}, never>;
}
