/**
 * al-select
 *
 * @author Rob Parker <robert.parker@alertlogic.com>
 *
 * @copyright Alert Logic, Inc 2021
 *
 */
import { EventEmitter, OnInit, ElementRef } from '@angular/core';
import { AlOptionItem } from '../../types';
import * as i0 from "@angular/core";
export declare class AlMultiSelectComponent implements OnInit {
    private eref;
    label?: string;
    default?: string;
    options: AlOptionItem[];
    inputModel: AlOptionItem[];
    search: boolean;
    itemSelected: EventEmitter<AlOptionItem[]>;
    searchText: string;
    optionsVisible: boolean;
    constructor(eref: ElementRef);
    ngOnInit(): void;
    clickOut(event: Event): void;
    closeOptions(): void;
    multiselectOption(checked: boolean, option: AlOptionItem): void;
    static ɵfac: i0.ɵɵFactoryDef<AlMultiSelectComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<AlMultiSelectComponent, "al2-multiselect", never, { "label": "label"; "default": "default"; "options": "options"; "inputModel": "inputModel"; "search": "search"; }, { "itemSelected": "itemSelected"; }, never, never>;
}
