import { PipeTransform } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * AlErrorCodeTranslatorPipe transforms the service, responseCode and responseMessage in a user friendly message
 *
 * @author Fábio Miranda <fmiranda@alertlogic.com>
 *
 * @copyright Alert Logic, Inc 2021
 */
export declare class AlErrorCodeTranslatorPipe implements PipeTransform {
    transform(service: string, responseCode: number, responseMessage: string): any;
    static ɵfac: i0.ɵɵFactoryDef<AlErrorCodeTranslatorPipe, never>;
    static ɵpipe: i0.ɵɵPipeDefWithMeta<AlErrorCodeTranslatorPipe, "alErrorCodeTranslator">;
}
