import { OnInit, EventEmitter } from '@angular/core';
import { AlSelectFilterItem, AlSelectFilterItemDetails } from './al-dropdown-filter.types';
import * as i0 from "@angular/core";
export declare class AlDropdownFilterComponent implements OnInit {
    /**
     * List of dashboard options
     */
    filterOptions: AlSelectFilterItem[];
    selectedOption: AlSelectFilterItem;
    /**
     * Optional width setting
     */
    dropDownWidth: string;
    /**
     * Event to  fire dashboard object
     */
    onFilterSelection: EventEmitter<AlSelectFilterItemDetails>;
    defaultWidth: string;
    ngOnInit(): void;
    clickEvent(item: AlSelectFilterItemDetails): void;
    static ɵfac: i0.ɵɵFactoryDef<AlDropdownFilterComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<AlDropdownFilterComponent, "al-dropdown-filter", never, { "filterOptions": "filterOptions"; "selectedOption": "selectedOption"; "dropDownWidth": "dropDownWidth"; }, { "onFilterSelection": "onFilterSelection"; }, never, never>;
}
