/**
 * @author Mario Payan <mario.payan@alertlogic.com>
 * @copyright 2019 Alert Logic, Inc.
 */
import { EventEmitter, OnInit } from '@angular/core';
import { DomSanitizer, SafeResourceUrl } from '@angular/platform-browser';
import * as i0 from "@angular/core";
export declare class AlHelpSidebarComponent implements OnInit {
    private sanitizer;
    visible: boolean;
    iframeContentUrl: string;
    learnMoreUrl: string;
    onOpen: EventEmitter<void>;
    onClose: EventEmitter<void>;
    iframeSafeResourceUrl: SafeResourceUrl;
    constructor(sanitizer: DomSanitizer);
    ngOnInit(): void;
    safeUrl: () => void;
    open: () => void;
    close: () => void;
    static ɵfac: i0.ɵɵFactoryDef<AlHelpSidebarComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<AlHelpSidebarComponent, "al-help-sidebar", never, { "visible": "visible"; "iframeContentUrl": "iframeContentUrl"; "learnMoreUrl": "learnMoreUrl"; }, { "onOpen": "onOpen"; "onClose": "onClose"; }, never, never>;
}
