/**
 * @author Stephen Jones <stephen.jones@alertlogic.com>
 * @copyright Alert Logic, Inc 2020
 */
import { OnInit, EventEmitter, ElementRef } from '@angular/core';
import { AlSelectorItem } from './al-selector.types';
import * as i0 from "@angular/core";
export declare class AlSelectorComponent implements OnInit {
    title: string;
    selectors: AlSelectorItem[];
    selected: EventEmitter<string>;
    container: ElementRef;
    private selectorCount;
    ngOnInit(): void;
    uniqueName: () => string;
    uniqueID: (index: number) => string;
    handleChange: (e: Event) => void;
    clear: () => void;
    private globalSelectorCount;
    static ɵfac: i0.ɵɵFactoryDef<AlSelectorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<AlSelectorComponent, "al-selector", never, { "title": "title"; "selectors": "selectors"; }, { "selected": "selected"; }, never, never>;
}
