import { EventEmitter, OnInit } from '@angular/core';
import { MultiSelect } from 'primeng-lts/multiselect';
import { AlSearchBarComponent } from "../al-search-bar/al-search-bar.component";
import * as i0 from "@angular/core";
export declare class AlTableCaption implements OnInit {
    cols: any[];
    defaultColumns: any[];
    storageKey: string;
    showColumnsSelector: boolean;
    showSearch: boolean;
    showDownload: boolean;
    donwloadLabel: string;
    useLocalStorage: boolean;
    get selectedColumns(): any[];
    searchPatternRegex: string | null;
    invalidSearchPatternText: string | null;
    onSearched: EventEmitter<string>;
    onChangeColumns: EventEmitter<any>;
    onInvalidSearchPattern: EventEmitter<void>;
    onDownload: EventEmitter<boolean>;
    multiSelect?: MultiSelect;
    alSearchBar?: AlSearchBarComponent;
    private selectedCols;
    ngOnInit(): void;
    openMultiselect(e: any): void;
    resetDefaultColumns(): void;
    storeColumnsSelections(columns: any[]): void;
    onSearchChanged(event: any): void;
    onDownloadAll(): void;
    set selectedColumns(val: any[]);
    static ɵfac: i0.ɵɵFactoryDef<AlTableCaption, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<AlTableCaption, "al-table-caption", never, { "cols": "cols"; "defaultColumns": "defaultColumns"; "storageKey": "storageKey"; "showColumnsSelector": "showColumnsSelector"; "showSearch": "showSearch"; "showDownload": "showDownload"; "donwloadLabel": "donwloadLabel"; "useLocalStorage": "useLocalStorage"; "selectedColumns": "selectedColumns"; "searchPatternRegex": "searchPatternRegex"; "invalidSearchPatternText": "invalidSearchPatternText"; }, { "onSearched": "onSearched"; "onChangeColumns": "onChangeColumns"; "onInvalidSearchPattern": "onInvalidSearchPattern"; "onDownload": "onDownload"; }, never, never>;
}
