import { OnInit, OnDestroy } from '@angular/core';
import { AlToastService } from '../services/al-toast.service';
import { MessageService } from 'primeng-lts/api';
import { AlToastButtonDescriptor } from './types/al-toast.types';
import * as i0 from "@angular/core";
export declare class AlToastComponent implements OnInit, OnDestroy {
    private alToastService;
    private messageService;
    key: string;
    position?: string;
    private showEmiter;
    private closeEmiter;
    constructor(alToastService: AlToastService, messageService: MessageService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    clickEvent(button: AlToastButtonDescriptor): void;
    private onShow;
    private onClose;
    static ɵfac: i0.ɵɵFactoryDef<AlToastComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<AlToastComponent, "al-toast", never, { "key": "key"; "position": "position"; }, {}, never, never>;
}
