import { PipeTransform } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * let longStr = 'A really long text which needs to be truncated';
 * {{longStr | AlTruncate }}
 * Output: A really long text which needs to be truncated
 * {{longStr | AlTruncate : 12 }}
 * Output: A really lon...
 * {{longStr | AlTruncate : 12 : true }}
 * Output: A really...
 * {{longStr | AlTruncate : 12 : false : '***' }}
 * Output: A really lon***
 */
export declare class AlTruncatePipe implements PipeTransform {
    transform(value: string, limit?: number, wordBreak?: boolean, ellipsis?: string): string;
    static ɵfac: i0.ɵɵFactoryDef<AlTruncatePipe, never>;
    static ɵpipe: i0.ɵɵPipeDefWithMeta<AlTruncatePipe, "AlTruncate">;
}
