export interface AlTreeTableColumnDef {
    header: string;
    headerTitle?: string;
    headerIcon?: string;
    headerIconClass?: string;
    tooltip?: string;
    type?: AlTreeTableColumnType;
    field: string;
    fieldTitle?: string;
    fieldIconClass?: string;
    fieldIconColor?: string;
    fieldIconOpacity?: string;
    filters?: AlTreeOptionItem[];
}
export declare enum AlTreeTableColumnType {
    text = "text",
    icon = "icon"
}
export interface AlTreeOptionItem {
    id: string | number;
    value?: any;
    label?: string;
    description?: string;
    icon?: string;
    tooltip?: string;
    iconClass?: string;
    selected?: boolean;
    expanded?: boolean;
    indeterminate?: boolean;
    highlighted?: boolean;
    disabled?: boolean;
    items?: AlTreeOptionItem[];
    data?: any;
}
