/**
 *  AlScoreCountDescriptor
 *
 *  @author maryit sanchez <msanchez@alertlogic.com>
 *
 *  @copyright Alert Logic Inc, 2018
 */
/**
 *  AlScoreCountDescriptor provides a class to describe a score count
 */
export declare class AlScoreCountDescriptor {
    critical: number;
    high: number;
    medium: number;
    low: number;
    none: number;
    info: number;
    count: number;
    /**
     *  Import
     *
     *  @param rawData array of objects
     *  @return AlScoreCountDescriptor
     */
    static import(rawData: {
        [property: string]: number;
    }): AlScoreCountDescriptor;
}
